/*FiSysMgr - Utiltiy gui program to help in editing /etc/fstab file.
  Copyright (C) 2015 Barry Strong bstrong@softtechok.com

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef BROWSEDLG_H
#define BROWSEDLG_H

#include "cifsinfo.h"
#include "fsdiskinfo.h"
#include "tablemodel.h"
#include "fstableview.h"
#include "fssortproxy.h"
#include "credsdialog.h"

extern SoundPlayer  *sPlayer;
extern Cifsinfo     cifsInfo;
extern FSDiskInfo   diskInfo;
extern QSettings    *settings;
extern QString      curCreds;

enum IdTypes {none, uuid, label, device};

namespace Ui {
    class BrowseDlg;
}

class BrowseDlg : public QDialog {
    Q_OBJECT

    public:
        explicit BrowseDlg(QWidget *parent = 0);
        ~BrowseDlg();
        void value(QString *device, QString *type) const;

    private:
        Ui::BrowseDlg   *ui;
        bool            loading;
        CifsShare       cShare;
        DiskDevice      diskDev;
        FSTableView     *FSList;
        TableModel      *fslModel;
        fsSortProxy     sortProxy;
        bool            deviceStat;
        bool            refreshStat;
        bool            stopStat;
        bool            listStat;
        bool            fsidStat;
        bool            applyStat;
        bool            cancelStat;
        QString         wrkGroup;
        QString         server;

        void reloadFS();
        void loadDisk();
        void showDisk();
        void loadSamba();
        void showSamba();
        void loadNFS();
        void showNFS();
        void saveBtns();
        void restoreBtns();
        void disableBtns();

    private slots:
        void currentItemChanged(const QModelIndex & current, const QModelIndex & parent = QModelIndex());
        void fslist_dblclicked();
        void on_pbApply_clicked();
        void on_pbCancel_clicked();
        void on_tbRefresh_clicked();
        void on_rbLocal_clicked();
        void on_rbSamba_clicked();
        void on_rbNFS_clicked();
        void on_tbScan_clicked();
};

#endif // BROWSEDLG_H
