/*FiSysMgr - Utiltiy gui program to help in editing /etc/fstab file.
  Copyright (C) 2015 Barry Strong bstrong@softtechok.com

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef CIFSINFO_H
#define CIFSINFO_H

#include <QObject>
#include <libsmbclient.h>

extern QString  workgroup;
extern QString  username;
extern QString  password;

struct CifsShare {
    QString workgroup;
    QString server;
    QString share;
    QString comment;
};

class Cifsinfo : public QObject {
    Q_OBJECT

    public:
        explicit Cifsinfo(QObject *parent = 0);
        ~Cifsinfo();
        bool refresh(const QString wg, const QString server);
        void setCancel();
        void setScanMode(int mode);
        int	shareCount () const;
        int numNewItems() const;
        int scanMode() const;
        const CifsShare & operator[] ( int idx ) const;

    private:
        SMBCCTX             *context;
        QList<CifsShare>    cifsShares;
        int                 nNewItems;
        static int          scanModeVal;

        static void credentials(const char *server, const char *share,
            char *workgroup, int wgmaxlen, char *user, int unmaxlen,
            char *pass, int pwmaxlen);
        bool scanDir(const QString wg, const QString server);

};

#endif // CIFSINFO_H
