/*FiSysMgr - Utiltiy gui program to help in editing /etc/fstab file.
  Copyright (C) 2015 Barry Strong bstrong@softtechok.com

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef CREDSDIALOG_H
#define CREDSDIALOG_H

#include <QDialog>
#include <QDir>
#include <QSettings>
#include <QMessageBox>
#include "soundplayer.h"
#include <QValidator>
#include <QRegExp>
#include <QKeyEvent>
#include <QLineEdit>
#include <QTimer>
#include <QTemporaryFile>
#include <QSortFilterProxyModel>

extern QSettings    *settings;
extern SoundPlayer  *sPlayer;

namespace Ui {
class CredsDialog;
}

class CredsDialog : public QDialog {
    Q_OBJECT

public:
    explicit CredsDialog(int mode = 0, QWidget *parent = 0);
    QString value();
    QString workgroup();
    QString username();
    QString password();
    void setValue(QString val);
    ~CredsDialog();

private slots:
    void on_pbOK_clicked();
    void on_pbDlgCancel_clicked();
    void loadCreds();
    void on_pbEdit_clicked();
    void on_pbSave_clicked();
    void on_pbCancel_clicked();
    void on_leDomain_editingFinished();
    void on_leUserName_editingFinished();
    void on_pbNewFile_clicked();
    void on_cbCredentials_currentIndexChanged(int index);

    void on_pbDelete_clicked();

    void on_pbClose_clicked();

private:
    Ui::CredsDialog         *ui;
    QString                 dirName;
    bool                    editMode;
    bool                    loading;
    QRegExp                 fnRegExp;
    QRegExpValidator        fnValidator;
    QSortFilterProxyModel   *sortProxy;
    bool writeline(QFile *file, QString data);
    bool write(QFile *file, QString data);
};

#endif // CREDSDIALOG_H
