/*FiSysMgr - Utiltiy gui program to help in editing /etc/fstab file.
  Copyright (C) 2015 Barry Strong bstrong@softtechok.com

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef FSMMAIN_H
#define FSMMAIN_H

#include <QMainWindow>
#include "tablemodel.h"
#include <QFile>
#include <QSortFilterProxyModel>
#include <QTableView>
#include <QSettings>
#include "backupdlg.h"
#include <QLocalServer>
#include <QLocalSocket>
#include "cifsinfo.h"
#include "fsdiskinfo.h"
#include <QDate>
#include "credsdialog.h"
#include "aboutbox.h"

extern SoundPlayer  *sPlayer;
extern QSettings    *settings;
extern Cifsinfo     cifsInfo;
extern QProcess     *helperProc;
extern FSDiskInfo   diskInfo;
extern QString      curCreds;

namespace Ui {
    class FsmMain;
}

class FsmMain : public QMainWindow {

    Q_OBJECT

    public:
        static QString fstabHash;
        explicit FsmMain(QWidget *parent = 0);
        ~FsmMain();

    private slots:
        void startup();
        void newLocalConnection();
        void on_action_About_triggered();
        void on_actionE_xIT_triggered();
        void on_fstabView_doubleClicked();
        void on_tbUp_clicked();
        void on_tbDown_clicked();
        void on_tbEdit_clicked();
        void on_tbDelete_clicked();
        void on_pbSave_clicked();
        void on_pbClose_clicked();
        void on_tbNew_clicked();
        void on_actionBackup_FileSystem_Config_triggered();
        void on_actionR_estore_Filesystem_Config_triggered();

        void on_action_Manage_Credentials_triggered();

private:
        Ui::FsmMain             *ui;
        int                     winWidth;
        int                     winHeight;
        int                     procreturn;
        TableModel              *fstabModel;
        QSortFilterProxyModel   filterProxy;
        QTableView              *fstabView;
        QFile                   fsFile;
        QTextStream             *fsStream;
        BackupDlg               *backupDlg;
        QLocalServer            *localServer;
        QLocalSocket            localSocket;
        QProcessEnvironment     hProcEnv;
        QString                 accessKey;
        QFile                   saveFile;
        QFile                   fstabFile;
        bool                    startupOK;

        bool loadfstab();
        void swapfields(int row, int row1, int column);
};

#endif // FSMMAIN_H
