/*FiSysMgr - Utiltiy gui program to help in editing /etc/fstab file.
  Copyright (C) 2015 Barry Strong bstrong@softtechok.com

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef OPTCHKBOX_H
#define OPTCHKBOX_H

#include <QCheckBox>
#include <QContextMenuEvent>

enum    ParamType {pnone, pint, pitm, poct, pstr};

class OptChkBox : public QCheckBox {
    Q_OBJECT

    public:
        explicit OptChkBox(QWidget *parent = 0);
        QString parameter();
        ParamType paramType();
        int minValue();
        int maxValue();
        QStringList cbValues();
        QStringList cbData();
        void setParamType(ParamType ptype);
        void setParameter(QString prm);
        void setMinValue(int val);
        void setMaxValue(int val);
        void addValue(QString val);
        void contextMenuEvent(QContextMenuEvent * event);

    private:
        int         minVal;
        int         maxVal;
        QString     param;
        ParamType   prmType;
        QStringList values;

    signals:
        void rightClicked(OptChkBox *chkBox);

    public slots:

};

#endif // OPTCHKBOX_H
