/*FiSysMgr - Utiltiy gui program to help in editing /etc/fstab file.
  Copyright (C) 2015 Barry Strong bstrong@softtechok.com

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef OPTIONSDLG_H
#define OPTIONSDLG_H

#include <QGridLayout>
#include "optchkbox.h"
#include "credsdialog.h"

extern QSettings    *settings;
extern QString      curCreds;

namespace Ui {
    class OptionsDlg;
}

class OptionsDlg : public QDialog
{
        Q_OBJECT

    public:
        explicit OptionsDlg(QWidget *parent = 0, QString type = "");
        ~OptionsDlg();
        QString value();
        void setValue(QString val);

    private slots:
        void on_cbDefaults_toggled(bool checked);
        void chkBoxToggled(bool checked);
        void on_pbApply_clicked();
        void on_pbCancel_clicked();
        void on_leOptions_editingFinished();
        void rightClicked(OptChkBox *chkBox);

private:
        Ui::OptionsDlg *ui;
        bool        updating;
        bool        loading;
        int         cboxRow;
        int         cboxCol;
        QStringList options;
        QGridLayout *layout;
        QString     fstype;
        QFile       resource;
        bool        editing;

        void buildInterface();
        void loadChkBoxes();
        void setDefaults();
        void unsetDefaults();
        void enableCbox(QString cb);
        void disableCbox(QString cb);
        bool editParam(OptChkBox *chkBox);
        bool credentials(OptChkBox *chkBox);
};

#endif // OPTIONSDLG_H
