/*FiSysMgr - Utiltiy gui program to help in editing /etc/fstab file.
  Copyright (C) 2015 Barry Strong bstrong@softtechok.com

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef PARAMDLG_H
#define PARAMDLG_H

#include <QValidator>
#include <QMessageBox>

namespace Ui {
class ParamDlg;
}

class ParamDlg : public QDialog
{
    Q_OBJECT

public:
    explicit ParamDlg(QWidget *parent = 0, bool combobox = false);
    ~ParamDlg();
    QString value();
    void setValue(QString val);
    void setValidator(QValidator *vld);
    void setLabel(QString val);
    void setcbValues(QStringList val);
    void setToolTip(QString tip);

private slots:
    void on_pbOk_clicked();
    void on_pbCancel_clicked();

private:
    Ui::ParamDlg    *ui;
    bool            cbox;

};

#endif // PARAMDLG_H
