/*FiSysMgr - Utiltiy gui program to help in editing /etc/fstab file.
  Copyright (C) 2015 Barry Strong bstrong@softtechok.com

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef SOUNDPLAYER_H
#define SOUNDPLAYER_H
#include <QtGlobal>

#if QT_VERSION < QT_VERSION_CHECK(5, 0, 0)
    #include <phonon/AudioOutput>
    #include <phonon/MediaObject>
    using namespace Phonon;
#else
    #include <QMediaPlayer>
#endif


class SoundPlayer : public QObject
{
        Q_OBJECT
    public:
        explicit SoundPlayer(QObject *parent = 0);
        void play(const QString src);

    signals:

    private:
#if QT_VERSION < QT_VERSION_CHECK(5, 0, 0)
        MediaObject     AudioObj;
        AudioOutput     *AudioOut;
#else
        QMediaPlayer    *player;
#endif

    public slots:

};

#endif // SOUNDPLAYER_H
