/*FiSysMgr - Utiltiy gui program to help in editing /etc/fstab file.
  Copyright (C) 2015 Barry Strong bstrong@softtechok.com

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "fsdiskinfo.h"
#include <unistd.h>

FSDiskInfo::FSDiskInfo(QObject *parent) : QObject(parent) {
}

bool FSDiskInfo::refresh() {

    QString     ws;
    QStringList wsl;
    DiskDevice  wd;
    int         timeout;

    while (! diskDevices.isEmpty())
        diskDevices.removeFirst();
    if (helperProc->write(accessKey.toLocal8Bit().data()) != accessKey.length())
        return false;
    if (helperProc->write(":scan\n") != 6)
        return false;
    ws = "";
    timeout = 0;
    do {
        if ((helperProc->state() != QProcess::Running) || (timeout > 300)) {
            ws = "failed";
            break;
        } else {
            helperProc->waitForReadyRead(10);
            usleep(100000);
        }
        while (helperProc->canReadLine()) {
            ws = helperProc->readLine();
            ws = ws.replace("\n","");
            if ((ws == "EOF") || (ws == "failed") )
                break;
            wsl = ws.split("\t");
            wd.Device = wsl[0];
            wd.Type = wsl[1];
            wd.UUID = wsl[2];
            wd.Label = wsl[3];
            diskDevices.append(wd);
        }
        timeout++;
    } while ((ws != "EOF") && (ws != "failed"));
    if (ws == "failed")
        return false;
    return true;
}

void FSDiskInfo::setAccessKey(QString key) {
    accessKey = key;
}

int FSDiskInfo::devCount() const {
    return diskDevices.size();
}

const DiskDevice & FSDiskInfo::operator[] (int idx) const {
    return diskDevices[idx];
}
