/*FiSysMgr - Utiltiy gui program to help in editing /etc/fstab file.
  Copyright (C) 2015 Barry Strong bstrong@softtechok.com

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "fssortproxy.h"

fsSortProxy::fsSortProxy(QObject *parent) : QSortFilterProxyModel(parent) {
}

void fsSortProxy::setSortMode(const SortMode sm) {
   sortMode = sm;
}

bool fsSortProxy::lessThan(const QModelIndex &left, const QModelIndex &right) const {

    int         leftRow;
    int         RightRow;
    int         compare;
    QModelIndex leftIndex;
    QModelIndex rightIndex;
    QString     leftValue;
    QString     rightValue;

    if (sortMode == local) {
        leftRow = left.row();
        RightRow = right.row();
        leftIndex = sourceModel()->index(leftRow, 0);
        rightIndex = sourceModel()->index(RightRow, 0);
        leftValue = sourceModel()->data(leftIndex).toString();
        rightValue = sourceModel()->data(rightIndex).toString();
        compare = QString::localeAwareCompare(leftValue, rightValue);
        if (compare < 0)
            return true;
    }
    if (sortMode == samba) {
        leftRow = left.row();
        RightRow = right.row();
        for (int idx = 0; idx < 3; idx++) {
            leftIndex = sourceModel()->index(leftRow, idx);
            rightIndex = sourceModel()->index(RightRow, idx);
            leftValue = sourceModel()->data(leftIndex).toString();
            rightValue = sourceModel()->data(rightIndex).toString();
            compare = QString::localeAwareCompare(leftValue, rightValue);
            if (compare != 0)
                break;
        }
        if (compare < 0)
            return true;
    }
    return false;
}
