/*FiSysMgr - Utiltiy gui program to help in editing /etc/fstab file.
  Copyright (C) 2015 Barry Strong bstrong@softtechok.com

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "optchkbox.h"

OptChkBox::OptChkBox(QWidget *parent) : QCheckBox(parent) {
    prmType = pnone;
    minVal = 0;
    maxVal = 0;
}

QString OptChkBox::parameter() {
    return param;
}

void OptChkBox::setParameter(QString prm) {
    param = prm;
}

ParamType OptChkBox::paramType() {
    return prmType;
}

void OptChkBox::setParamType(ParamType ptype) {
    prmType = ptype;
}

void OptChkBox::setMinValue(int val) {
    minVal = val;
}

void OptChkBox::setMaxValue(int val) {
    maxVal = val;
}

int OptChkBox::minValue() {
    return minVal;
}

int OptChkBox::maxValue() {
    return maxVal;
}

void OptChkBox::addValue(QString val) {
    values.append(val);
}

QStringList OptChkBox::cbValues() {
    return values;
}

void OptChkBox::contextMenuEvent(QContextMenuEvent *) {
    emit rightClicked(this);
}
