/*FiSysMgr - Utiltiy gui program to help in editing /etc/fstab file.
  Copyright (C) 2015 Barry Strong bstrong@softtechok.com

  This program is free software: you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation, either version 3 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#include "soundplayer.h"

SoundPlayer::SoundPlayer(QObject *parent) : QObject(parent) {
#if QT_VERSION < QT_VERSION_CHECK(5, 0, 0)
    AudioOut = new AudioOutput(Phonon::NotificationCategory, this);
    createPath(&AudioObj, AudioOut);
#else
    player = new QMediaPlayer(this);
#endif
}

void SoundPlayer::play(const QString src) {
#if QT_VERSION < QT_VERSION_CHECK(5, 0, 0)
    AudioObj.setCurrentSource(QUrl(src));
    AudioObj.play();
#else
    player->setMedia(QUrl(src));
    player->play();
#endif
}
